//*******************************************************************************************
// Flaske.java
// 
// INF100, ving 5, oppgave 4.5 
// Vannflaske
//*******************************************************************************************

/** Klassen representerer vannflasker med gitt kapasitet, som til enhver tid
 *  er fylt med en viss mengde vann. Klassen inneholder metoder for  fylle og
 *  tmme flasker helt, samt  helle vann fra en flaske til en annen.
 */

public class Flaske 
{

    /** Maksimumkapasiteten til flasken mlt i liter. */
    private double kapasitet;

    /** Alle flasker har til enhver tid en viss mengde vann,
     *  ogs mlt i liter.
     */
    private double mengde;

    /** Denne konstruktren oppretter et flaske-objekt med
     *  kapasitet gitt ved parameteren. Flasken som blir laget
     *  er i utgangspunktet tom.
     */
    public Flaske(double kap) 
    {
        kapasitet = kap;
	// Den neste linjen er egentlig ikke ndvendig siden
	// standardverdien til feltvariabelen mengde er 0.0
	// fra fr.
        mengde = 0.0;
    }   

    /** Returnerer antall liter vann som er p flasken for
     *  yeblikket.
     */
    public double vannMengde() 
    {
        return mengde;
    }
    
    /** Returnerer antall liter vann som kan fylles p flasken fr
     *  den er full.
     */
    public double ledigPlass() 
    {
        return kapasitet - mengde;
    }

    /** Fyller flasken helt opp */
    public void fyllFull() 
    {
        mengde = kapasitet;
    }
    
    /** Tmmer flasken helt. */
    public void tm() 
    {
        mengde = 0.0;
    }
    
    /** Heller over vann fra flasken gitt som parameter til
     *  den aktuelle flasken.  Mengden med vann som blir tmt over fra
     *  den ene flasken til den andre er begrenset enten av
     *  kapasiteten til flasken som tar imot vannet, eller mengden
     *  med vann som er tilgjengelig i flasken vannet kommer fra.
     */
    public void hellOver(Flaske fraFlaske) 
    {
	// Er det plass til alt vannet i fraFlaske?
	if (fraFlaske.mengde <= ledigPlass()) {
	    // Vi har plass til alt vannet i fraFlaske
	    this.mengde += fraFlaske.mengde;
	    // Vi kan egentlig slyfe this-referansen, men tar den med for  gjre
	    // det tydeligere hvilken av de to flaskene det gjelder
	    fraFlaske.tm();
	}
	else {
	    // Vi har ikke plass til alt
	    fraFlaske.mengde -= this.ledigPlass();
	    this.fyllFull();
	}
    }
}

